%% This script demonstrates the reduction in over-fitting as more data 
 % is used. A polynomial is fit using ML estimation to 10, 15, 100 and 300
 % data points respectively.
 % Reduction in over-fitting can be seen via
 %  1) increased RMS training error
 %  2) better approximation of original function (green) by the  fitted curve (red)
clf;
M=9;
lambda=0;
newx=0:.01:1;

load data_10;
[w,beta,E_RMS_train]=fit_polynomial_ML(x,t,M,lambda);
subplot(221);
plot_fitting_results(newx,w,x,t);
title(['E_{RMS}=' num2str(E_RMS_train)]);
text(.2,-1.3,['$N=$' num2str(10)],'Interpreter','Latex');

load data_15;
[w,beta,E_RMS_train]=fit_polynomial_ML(x,t,M,lambda);
subplot(222);
plot_fitting_results(newx,w,x,t);
title(['E_{RMS}=' num2str(E_RMS_train)]);
text(.2,-1.3,['$N=$' num2str(15)],'Interpreter','Latex');

load data_100;
[w,beta,E_RMS_train]=fit_polynomial_ML(x,t,M,lambda);
subplot(223);
plot_fitting_results(newx,w,x,t);
title(['E_{RMS}=' num2str(E_RMS_train)]);
text(.2,-1.3,['$N=$' num2str(100)],'Interpreter','Latex');

load data_300;
[w,beta,E_RMS_train]=fit_polynomial_ML(x,t,M,lambda);
subplot(224);
plot_fitting_results(newx,w,x,t);
title(['E_{RMS}=' num2str(E_RMS_train)]);
text(.2,-1.3,['$N=$' num2str(300)],'Interpreter','Latex');

print(gcf,'Figure_1_6','-dpng');